﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace exemploabstracao
{
    class Program
    {

        public abstract class funcionario
        {
            //estes atributos valerão para todos
            public string matricula { get; set; }
            public string nome { get; set; }

            //este método vale para todos
            public void mostra_funcionario()
            {
                Console.WriteLine("Matrícula: {0} - Nome: {1}", this.matricula, this.nome);
            }
            //este método será abstrato e deve ser
            //declarado nas classes filhas
            public abstract double comissao();
        }

        public class vendedor : funcionario
        {
            public override double comissao()
            {
                return Convert.ToDouble("10,5");

            }

        }

        public class atendente : funcionario
        {
            public override double comissao()
            {
                return Convert.ToDouble("5");

            }
        }

        public class entregador : funcionario
        {
            public override double comissao()
            {
                return Convert.ToDouble("0");

            }
        }




        static void Main(string[] args)
        {
            vendedor paulo = new vendedor();
            atendente maria = new atendente();
            entregador igor = new entregador();
            
            double vendas;
            Console.Write("Qual o total das vendas?");
            vendas = Convert.ToDouble(Console.ReadLine());
            paulo.matricula = "00001-3";
            maria.matricula = "00002-5";
            igor.matricula = "00003-9";
            paulo.nome = "Paulo Joaquim Almeida";
            maria.nome = "Maria Aparecida Silva";
            igor.nome = "Igor Amaral";
            paulo.mostra_funcionario();
            Console.WriteLine("Vendas totais: R$ {0} - Comissão total: R$ {1}", vendas, (vendas *paulo.comissao()) / 100);
            maria.mostra_funcionario();
            Console.WriteLine("Vendas totais: R$ {0} - Comissão total: R$ {1}", vendas, (vendas * maria.comissao()) / 100);
            igor.mostra_funcionario();
            Console.WriteLine("Vendas totais: R$ {0} - Comissão total: R$ {1}", vendas, (vendas * igor.comissao()) / 100);
            Console.ReadKey();

        }
    }
}
